local ADDON_NAME = ...


local UsedNamesList = { 
    "Plaff",
    "Kota",
    "Jaboli"
}
UsedNamesList["Plaff"] = {
    "Ludwig.mp3",
}
UsedNamesList["Kota"] = {
    "Kota2.mp3",
    "bigpump2.mp3"
}
UsedNamesList["Jaboli"] = {
    "fuckingshittingme.mp3",
    "neverbefore.mp3",
    "whatdidido.mp3",
    "ressme.mp3",
    "notankbrain.mp3"
}

local ObserversList = {}
local group = {}
local newgroup = {}

local IsMaster = true
local Master = ""



--# helper functions --
local function startsWith(string, start)
    if start == nil then
        return false
    end

    return string.sub(string, 1, string.len(start)):lower() == start:lower()
end

local function is_target(name)
    for index, value in ipairs(UsedNamesList) do
        if startsWith(name, value) then
            return value
        end
    end
    return nil
end

local function has_value(list, value)
    for i, v in ipairs(list) do
        if v == value then
            return true
        end
    end
end

function send_addon_check(target)
    if target == nil or not UnitIsConnected(target) then
        return 
    end 
    name = UnitName("player")
    --print("CHECK sent to", target)
    C_ChatInfo.SendAddonMessage("LWGD", "CHECK_" .. name, "WHISPER", target)
end

function broadcast_addon_check(channel)
    if channel == nil then
        return 
    end 
    name = UnitName("player")
    --print("CHECK sent to", channel)
    C_ChatInfo.SendAddonMessage("LWGD", "CHECK_" .. name, channel)
end

function get_group_type()
    if not IsInGroup() then
        return "solo"
    end

    local n, unit = GetNumGroupMembers(), "raid"
    if not IsInRaid() then
        n, unit = n - 1, "party"
    end

    return unit, n
end

function send_play(sound)
    local channel = (get_group_type())

    if channel ~= "solo" then
        --print("PLAY sent to", channel)
        C_ChatInfo.SendAddonMessage("LWGD", "PLAY_" .. sound , channel)
    else
        PlaySoundFile("Interface\\addons\\LudwigGoesDown\\media\\" .. sound, "Master")
    end
end

function sort_table_by_value(tbl, sortFunction)
    local keys = {}
    for key in pairs(tbl) do
      table.insert(keys, key)
    end
  
    table.sort(keys, function(a, b)
      return sortFunction(tbl[a], tbl[b])
    end)
  
    return keys
end

function set_new_master()
    local tbl = sort_table_by_value(ObserversList,  function(a, b) return a < b end)
    local new_tbl = {}
    for i,k in pairs(tbl) do
        local t_name = ObserversList[k]
        if UnitIsConnected(t_name) then
            tinsert(new_tbl, t_name)
        end
    end
    ObserversList = new_tbl
    if ObserversList[1] ~= nil and ObserversList[1] == (UnitName("player")) then
        IsMaster = true
        if Master ~= ObserversList[1] then
            --print("You're the master")
            Master = ObserversList[1]
        end
     
    elseif ObserversList[1] ~= nil then
        IsMaster = false
        if Master ~= ObserversList[1] then
            --print("New master is", ObserversList[1])
            Master = ObserversList[1]
        end
    end
end


--# end helper functions --

local function check_player(self, event)
    local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = CombatLogGetCurrentEventInfo()

    if subevent == "UNIT_DIED" and IsMaster then
        name = is_target(destName)
        if name ~= nil then
            local soundIndex, array, sound
            local soundCount = table.getn(UsedNamesList[name])
           
            soundIndex = math.random(1, soundCount)
            array = UsedNamesList[name]
            sound = array[soundIndex]
            send_play(sound)
        end
    end
    return false
end

LWGD = { }
LWGD.eventListener = CreateFrame("Frame", "LWGDEvents")
LWGD.eventListener:RegisterEvent("ADDON_LOADED")
LWGD.eventListener:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
LWGD.eventListener:RegisterEvent("PLAYER_LOGOUT")
LWGD.eventListener:RegisterEvent("PLAYER_LOGIN")
LWGD.eventListener:RegisterEvent("GROUP_ROSTER_UPDATE")
LWGD.eventListener:RegisterEvent("CHAT_MSG_ADDON")


local DB = {
    UsedNames = UsedNamesList
}

local function SlashCommands(msg, editbox)
    if msg == 'list' then
        print("Total players with LWGD: " .. table.getn(ObserversList))

        for i, v in pairs(ObserversList) do
            local name = ObserversList[i]
            if name == Master then
                print("|cff22ff22Master|r", ObserversList[i])
            else
                print("|cffff2222Observer|r", ObserversList[i])
            end
        end
    end
  end
  
  SLASH_LWGD1 = '/lwgd'
  
SlashCmdList["LWGD"] = SlashCommands

LWGD.eventListener:SetScript("OnEvent",
function(self, event, ...)
    if event == "ADDON_LOADED" then
        local name = ...
        if name == "LudwigGoesDown" then
            C_ChatInfo.RegisterAddonMessagePrefix("LWGD");
            LWGD:CreateOptions()
            --print("ADDON_LOADED")
        end
    elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
        check_player(event)
    elseif event == "PLAYER_LOGOUT" then
    elseif event == "PLAYER_LOGIN" then
        --print("PLAYER_LOGIN")
        local grp = (get_group_type())

        if ObserversList ~= nil then
            wipe(ObserversList)
        end

        if grp ~= "solo" then
            broadcast_addon_check(grp)
        end

    elseif event == "GROUP_ROSTER_UPDATE" then
        --print("GROUP_ROSTER_UPDATE")
        local grp, count = get_group_type()
        if grp ~= "solo" then
            if grp == "party" then
                local found = false
                for i, k in pairs(ObserversList) do
                    if ObserversList[i] == (UnitName("player")) then
                        found = true
                        break
                    end
                end
                if not found then
                    tinsert(ObserversList, (UnitName("player")))
                end
            end
            
            group, newgroup = newgroup, group
            wipe(newgroup)
            for i = 1, count do
                local name = GetUnitName(grp..i, true)
                if name and name ~= UNKNOWN then
                    newgroup[name] = i
                end
            end

            for name, index in pairs(newgroup) do
                if not group[name] then
                        --print(name, "joined the group.")
                end
            end
            for name, index in pairs(group) do
                if not newgroup[name] then
                    --print(name, "left the group.")
                
                    for i, v in pairs(ObserversList) do
                        if v == name then
                            tremove(ObserversList, i)
                            --print("Removed", name, "from observerslist")
                            break
                        end
                    end
                end
            end
            broadcast_addon_check(grp)
        else    
            if ObserversList ~= nil then
                wipe(ObserversList)
            end
            IsMaster = true
            --print("SOLO: You're the master")
        end

    elseif event == "CHAT_MSG_ADDON" then
        local prefix, text, _, message_sender = ...
        if prefix == "LWGD" then
            if startsWith(text, "CHECK_") then
                local myName = UnitName("player")
                local sender = strsub(text, 7)

                --print("CHECK from", sender)
                C_ChatInfo.SendAddonMessage("LWGD", "ACK_" .. myName, "WHISPER", sender)
                --print("ACK_" .. myName .. " sent to", sender)

            elseif startsWith(text, "ACK_") then
                local sender = strsub(text, 5)
                --print("ACK from", sender)

                local found = false
                for index, name in pairs(ObserversList) do
                    if name == sender then
                        found = true
                        break
                    end
                end
                if not found then
                    tinsert(ObserversList, sender)
                end

                set_new_master()

            elseif startsWith(text, "PLAY_") then
                local sound = strsub(text, 6)
                local name_without_realm
                local dash = (string.find(message_sender, '-', 1, true))
                if dash >= 1 then
                    name_without_realm = strsub(message_sender,1, dash - 1)
                else
                    name_without_realm = message_sender
                end
                if name_without_realm == Master then
                    --print("PLAY from Master:", name_without_realm, "soundfile:", sound)
                    PlaySoundFile("Interface\\addons\\LudwigGoesDown\\media\\" .. sound, "Master")
                end
            end    
        end
    end
end)



function LWGD:CreateOptions(self)
    LWGD.panel = CreateFrame( "Frame", "LWGDPanel", UIParent );
    LWGD.panel.name = "Ludwig Goes Down";
    InterfaceOptions_AddCategory(LWGD.panel);

    LWGD.panel.title = LWGD.panel:CreateFontString(nil,"ARTWORK","GameFontNormalLarge")
    LWGD.panel.title:SetPoint("TOPLEFT",16,-16)
    LWGD.panel.title:SetText("Ludwig Goes Down! |cff0088eev("..GetAddOnMetadata(ADDON_NAME,"Version")..")|r")

    LWGD.panel.description1 = LWGD.panel:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall")
    LWGD.panel.description1:SetPoint("TOPLEFT",LWGD.panel.title,"BOTTOMLEFT",0,-2)
    LWGD.panel.description1:SetText("Addon created by <Requiem> Plaffs - Doomhammer (EU)")
    LWGD.panel.description1:SetJustifyH("LEFT")
    LWGD.panel.description1:SetWidth(592)


    --LWGD:CreateNamesList()
    --LWGD:CreateInput()
end

function LWGD:CreateNamesList(self)
    LWGD.panel.label1 = LWGD.panel:CreateFontString(nil,"ARTWORK","GameFontNormalLarge")
    LWGD.panel.label1:SetPoint("TOPLEFT",LWGD.panel.description1,"BOTTOMLEFT",0,-4)
    LWGD.panel.label1:SetText("Names list")

    LWGD.panel.namelist = CreateFrame("ScrollFrame", "LWGDNameList", LWGD.panel);
    LWGD.panel.namelist:SetPoint("TOPLEFT",LWGD.panel.label1, "BOTTOMLEFT", 0, -24);
    LWGD.panel.namelist:SetSize(550, 175);

    LWGD.panel.namelist:SetBackdrop({
        bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        tile = true,
        tileSize = 5,
        edgeSize = 4
    });
    LWGD.panel.namelist:SetBackdropColor(0, 0, 0, 0.5);
    itemcnt = 0;
    first = true;
    max_rows = 8
    for idx, name in ipairs(LWGDDb.AllNames) do
        if first then
            LWGDCheckButton = CreateFrame("CheckButton",
                                        "LWGDCheckButton_" .. idx,
                                        LWGDNameList,
                                        "UICheckButtonTemplate");
            first = false;
            LWGDCheckButton:SetSize(25,25);
            LWGDCheckButton:SetPoint("TOPLEFT", 0, 0);
        else
            LWGDCheckButton = CreateFrame("CheckButton",
                                        "LWGDCheckButton_" .. idx,
                                        LWGDNameList,
                                        "UICheckButtonTemplate");
            LWGDCheckButton:SetSize(25,25);
            LWGDCheckButton:SetParent("LWGDCheckButton_" .. anchor);
            if ((itemcnt % max_rows) ~= 0) then
                LWGDCheckButton:SetPoint("TOPLEFT", 0, -20);
            else
                LWGDCheckButton:SetPoint("TOPLEFT", 150, (max_rows - 1)*20);
            end
        end
        itemcnt = itemcnt + 1;
        anchor = idx;


        getglobal(LWGDCheckButton:GetName() .. "Text"):SetText(name);
        if (getglobal("LWGDCheckButton_" .. idx):GetChecked() ~= has_value(LWGDDb.UsedNames, name)) then
            getglobal("LWGDCheckButton_" .. idx):SetChecked(
                has_value(LWGDDb.UsedNames, name)
            );
        end
        LWGDCheckButton:SetScript("OnClick", function(self)
            if (self:GetChecked()) then
                if has_value(LWGDDb.UsedNames, name) then
                    return
                else
                    table.insert(LWGDDb.UsedNames, name)
                end
            else
                if has_value(LWGDDb.UsedNames, name) then
                    idx_to_remove = -1
                    for idx, val in ipairs(LWGDDb.UsedNames) do
                        if val == name then
                            idx_to_remove = idx
                            break
                        end
                    end

                    if idx_to_remove ~= -1 then
                        table.remove(LWGDDb.UsedNames, idx_to_remove)
                    end
                end
            end
        end);

    end
end
function LWGD:CreateInput(self)

    LWGD.panel.inputTitle = LWGD.panel:CreateFontString(nil,"ARTWORK","GameFontNormalSmall")
    LWGD.panel.inputTitle:SetPoint("TOPLEFT",LWGD.panel.namelist, "BOTTOMLEFT", 16,-16)
    LWGD.panel.inputTitle:SetText("Add name")

    LWGD.panel.input = CreateFrame("EditBox", "LWGDInput", LWGD.panel)
    LWGD.panel.input:SetPoint("TOPLEFT", LWGD.panel.inputTitle, "BOTTOMLEFT", 0, -24);
    LWGD.panel.input:SetMultiLine(false)   
    LWGD.panel.input:SetAutoFocus(false)

end
